Modify

#1021 closed enhancement (fixed)

Support for Jabber XEP-0280, "Carbons"

Reported by: bitlbee@… Owned by:
Priority: normal Milestone:
Component: BitlBee Version: 3.0.6
Keywords: jabber xep 0280 carbons multi-client mobile patch Cc:
IRC client+version: Client-independent Operating System: Public server
OS version/distro:

Description

In todays communications-world with a ever growing dualism of users using both desktop, and mobile platorms (smartphones, tablets, etc) at the same time, good support for those use-cases is important.

For one thing, consider the use-case where a user has a jabber client (bitlbee) running and connected on a desktop box, and has to leave taking his/her smartphones with a mobile jabber client with him. Now a friend has something important to tell him (maybe his/her GF/BF wants her/him to buy additional tomatoes), and sends a jabber message. On some clients you can choose the resource to send to, other attempt to identify the correct resource by other means, even others don't even try to care. This is where carbons comes in handy: If configured, the user is sure to receive this message or a copy on his/her mobile client.

With support for carbons in prosody, and soon in yaxim, an android jabber client, it'd be great to have some desktop client support it. My favorite is bitlbee, so i'd be really grateful if this could be implemented soon!

Best Regards

  • Dario Ernst

Attachments (1)

bitlbee-3.2.0-r994-carbons.patch (11.9 KB) - added by Stephen Shirley <kormat@…> at 2013-07-02T11:29:22Z.

Download all attachments as: .zip

Change History (11)

comment:1 Changed at 2013-02-05T15:40:49Z by Stanislav Ochotnicky <sochotnicky@…>

Indeed it would be nice to be able to integrate bitlbee more nicely with my mobile client.

OT: It would be nice if I was able to simply add myself to CC without actually adding a comment :-)

comment:2 Changed at 2013-02-05T15:47:43Z by Flexo <bitlbee@…>

Testing whether Stanislav receives this e-mail.

Changed at 2013-07-02T11:29:22Z by Stephen Shirley <kormat@…>

comment:3 Changed at 2013-07-02T11:29:42Z by Stephen Shirley <kormat@…>

I have written a patch against bzr rev 994 (bitlbee 3.2.0) that adds Carbons support. My C is a bit rusty, and i'm new to the codebase, so careful review and feedback requested :)

comment:4 Changed at 2013-07-02T11:41:00Z by Stephen Shirley <kormat@…>

A few comments on my implementation:

  • I'm looking for feedback before i go any further, but right support is functionally complete
  • Tested using prosody 0.8.2 (but with carbons support taken from 0.9.0rc) and irssi 0.8.15.
  • It queries for carbons support and automatically enables it if present. This should probably be a setting.
  • IRC doesn't provide a way for the server to tell the client "hi, you sent this message", so displaying forwarded messages that you have sent from another client is non-trivial. I've worked around this by hacking NOTICEs. It's definitely not pretty, but is the least bad way i can find. This definitely needs testing on other irc clients, and almost certainly needs a setting to customize how this display is done.

comment:5 Changed at 2013-07-06T13:28:51Z by Stephen Shirley <kormat@…>

For anyone who wants to review/test this patch, i'm happy to give you an account on my jabber server which has carbons support. Just let me know.

comment:6 Changed at 2013-07-07T13:37:43Z by Stephen Shirley <kormat@…>

Patch review in progress here: http://code.bitlbee.org/rb/r/33/

comment:7 Changed at 2014-02-04T05:06:05Z by dx

  • Keywords patch added

comment:8 Changed at 2015-05-16T12:57:45Z by me@…

I can't seem to find a status update about this patch. The link to the patch review 404's. Does Bitlbee do carbons yet?

comment:9 Changed at 2015-06-17T11:57:46Z by glance

I would love to see this functionality in bitlbee.

comment:10 Changed at 2015-11-21T03:12:56Z by dx

  • Resolution set to fixed
  • Status changed from new to closed

Done!

https://github.com/bitlbee/bitlbee/commit/fa8f57b7f51a44ee0870d1bf29646007e087f24e

Loosely based on a patch by kormat from trac ticket 1021. (Thanks!)

I moved stuff around, simplified things, fixed a few bugs, and used the new self-messages feature.

It's not obvious in this ticket (which has been rather silent) but this patch went through a lot before becoming that commit. Most notably, the self-messages part is no longer just a hack, but a core feature of bitlbee.

Add Comment

Modify Ticket

Action
as closed The ticket will remain with no owner.
The resolution will be deleted. Next status will be 'reopened'.
Author


E-mail address and user name can be saved in the Preferences.

 
Note: See TracTickets for help on using tickets.